//import processing.opengl.*;


int r = 100;
int dr = 7;
float angle = 30;
float inc = 0.0005;
//String sound;
import ddf.minim.*;
import ddf.minim.analysis.*;

Minim minim;

AudioPlayer player;
AudioInput in;
FFT fft;
FFT fftLin;
FFT fftLog;
BeatDetect beat;
BeatDetect beatF;
BeatListener bl;
BeatListener bl2;
int sampleRate= 44100;//sapleRate of 44100
float volGauche =0.0;
float   volDroit =0.0;
float [] max= new float [sampleRate/2];//array that contains the half of the sampleRate size, because FFT only reads the half of the sampleRate frequency. This array will be filled with amplitude values.
float maximum;//the maximum amplitude of the max array
float frequency;//the frequency in hertz
float avg=255;
float valeur = 0;
float minFreq= 0;
float maxFreq = 15;
boolean tempo = false;
boolean range = false;
String note;// name of the note
int n;//int value midi note
color c;//color
float hertz;//frequency in hertz
float midi;//float midi note
int noteNumber;//variable for the midi note

float kickSize, snareSize, hatSize;
boolean hat, kick, snare;
boolean premiere = false;
float a,b,x,y;
ArrayList<Float> listeA= new ArrayList<Float>();
ArrayList<Float> listeB= new ArrayList<Float>();
ArrayList<Float> listeX= new ArrayList<Float>();
ArrayList<Float> listeY= new ArrayList<Float>();


void setup() {
  size(1024, 768,P3D); 
  //
  minim = new Minim(this);
  in = minim.getLineIn(Minim.STEREO, 2048, 44100);
  player = minim.loadFile("Abba.mp3", 2048);
  //player.play();
  fft = new FFT(in.mix.size(), 44100);
  fftLog = new FFT(in.bufferSize(), in.sampleRate());
  //  // calculate averages based on a miminum octave width of 22 Hz
  //  // split each octave into three bands
  //  // this should result in 30 averages
  fftLog.logAverages(22, 3); 


  //beat = new BeatDetect();
  beatF = new BeatDetect(in.bufferSize(), 44100);

  //beat.setSensitivity(10);  
  beatF.setSensitivity(100); 
  kickSize = snareSize = hatSize = 64;
  bl = new BeatListener(beatF, in);
}

void draw() {
  
  if(!premiere){
 background(0);

    textSize(36);
    translate(width/2, height/2);
    fill(255, 180, 8);
    text("Gimme! Gimme! Gimme! (A Man After Midnight)", -410, 0);
    textSize(36);
    text ("Abba - 1979", -130, 60);
    textSize(16);
    text("Philippe Castellin - 2018", 250, 350);
    println("premiere======" + premiere);
    
  }
 if(premiere){ 
  //if(frameCount%5==0){
background(50, 30);
  //}
frameRate(25);
listeA= new ArrayList<Float>();
listeB= new ArrayList<Float>();
listeX= new ArrayList<Float>();
listeY= new ArrayList<Float>();

//println("taillelisteA=======" +listeA.size());
  //
  findNote();///frequence et note
  
  //
      for(int i = 0;i<24; i++){
 if ( beatF.isOnset(i) ){
//println("tempsfort==========");

tempo = true;

 }else{
  tempo = false;
  
  
 }
  }
 
 int lowBand = 15;
  int highBand = 25;
  // at least this many bands must have an onset 
  // for isRange to return true
  int numberOfOnsetsThreshold = 1;
  if ( beatF.isRange(lowBand, highBand, numberOfOnsetsThreshold) )
  {
    range=true;
    //println("range!!!!!!!");
//    fill(232,179,2,200);
//    rect(100*lowBand, 0, (highBand-lowBand)*100, height);
  }else{
    range= false;
  }
  
  if (beatF.isSnare()) {
    spotLight(255, 0, 0, -70, 300, 100, 0, 0, -1, PI/2, 30);
    snare=true;
    hat = false;
    kick=false;
    //rotateZ(PI);
    //pixels[j * width + i] = tex.pixels[ ((h) * width) + i];
    //h=h +1;
    //println("snare");
  }
  if (beatF.isKick()) {
    spotLight(255, 200, 255, 900, 500, 500, 0, 0, -1, PI/2, 100);
    snare=false;
    hat= false;
    kick=true;
    //pixels[j * width + i] = tex.pixels[((j + h) % (height)) * width + i];
    //h=h+1/2;
    //println("kick");
  }
  if (beatF.isHat()) {
    //println("hat");
    hat = true;
    snare = false;
    kick = false;
    // h=h*3;
    // pixels[j * width + i] = tex.pixels[((j + amp) % height) * width + i];
    spotLight(0, 255, 255, 400, 600, 200, 0, 0, -1, PI/2, 50);
  }
  else {
    hat = false;
  }
  
  
  //

    beatF.detect(in.mix);


  volGauche =in.left.level();////volume gauche
  volDroit =in.right.level();////volume droit

  translate(width/2, height/2,frequency*0.4);
if(hat){  
  rotateY(angle+inc);
}else if(snare){
   rotateX(angle+inc);
}else{
  rotateZ(angle-inc);
}
  //let waveform = fft.waveform();
  fill(255, 80);
  //println(avg*100);
  ellipse(0+avg*1000, 0+avg*1500, 800*volGauche, frequency);
  noFill();

  fftLog.forward(in.mix);
  
  beginShape();
  stroke(255, 100,frequency); 
  strokeWeight(1+avg/2);
  for (int i = 0; i < fftLog.avgSize(); i++) {
r= int(random(10,200));
dr= int(random(10,200));
    avg = fftLog.getAvg(i)*1;
    float ang = i*360/fftLog.avgSize();
     x = (r)*cos(radians(ang));
     listeX.add(x);

     y = (r)*sin(radians(ang));
     listeY.add(y);

    a = map(avg, -1, 1, r-dr, r+dr)*cos(radians(ang));// ;
    listeA.add(a);
    //println(a);
    b = map(avg, -1, 1, r-dr, r+dr)*sin(radians(ang));// 
    listeB.add(b);;
    vertex(a, b);
    //pushMatrix();
    //  translate(width/2, height/2,frequency*0.4);
//if(h//at){  
  ////rotateY(angle-inc);
//}els//e if(snare){
   ////rotateX(angle+inc);
//}
  ////  strokeWeight(1+avg);
    //stroke(255, a, b,frequency/10);
    //line(x, y, a, b);
    //popMatrix();
    pushMatrix();
    stroke(255);
    strokeWeight(2+avg);
    point(a, b);
    if(avg>60){
      noStroke();
      fill(255,220,200,50);
    sphere(a);
    }
    popMatrix();
    //println("avginit========"+ avg);
    //println(avg);
  }

  endShape();
  //println("taillelisteA=======" +listeA.size());
  pushMatrix();
   translate(width/2, height/2,frequency*0.4);
if(hat){  
  rotateY(angle-inc);
}else if(snare){
   rotateX(angle+inc);
}for (int i = 0; i < fftLog.avgSize(); i++) {
  strokeWeight(1+avg*100);
    stroke(255, a, b,frequency/10);
    float xbis= listeX.get(i);
    float ybis =listeY.get(i);
    float abis=listeA.get(i);
    float bbis =listeB.get(i);
    line(xbis, ybis, abis, bbis);
}
    popMatrix();

inc++;
 }
 
 if(!player.isPlaying() && premiere){
   this.stop();
   exit();
 }
}



void findNote() {

  fft.forward(in.mix);
  for (int f=0;f<sampleRate/2;f++) { //analyses the amplitude of each frequency analysed, between 0 and 22050 hertz
    max[f]=fft.getFreq(float(f)); //each index is correspondent to a frequency and contains the amplitude value
  }
  maximum=max(max);//get the maximum value of the max array in order to find the peak of volume

  for (int i=0; i<max.length; i++) {// read each frequency in order to compare with the peak of volume
    if (max[i] == maximum) {//if the value is equal to the amplitude of the peak, get the index of the array, which corresponds to the frequency
      frequency= i;
    }
  }


  midi= 69+12*(log((frequency-6)/440));// formula that transform frequency to midi numbers
  n= int (midi);//cast to int
  //println(n);
  
  if(player.isPlaying()==false){
    this.stop();
    exit();
  }
};

void mouseReleased(){
  if(!premiere){
    premiere = true;
    player.play();
  }
}

void stop()
{
 // always close Minim audio classes when you are done with them
 in.close();
 minim.stop();

 super.stop();
}